﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace erettsegi11_Automata
{
    class erettsegi11_Automata
    {
        struct rekesz
        {
            public int r_ssz;
            public int db;
            public int ár;
            //2. feladathoz
            public int érték { get { return ár * db; } }
        }

        struct vásárlás
        {
            public int vssz;//6. feladathoz
            public int vrek;
            public int vdb;
            public int[] érmék;
            //6. feladathoz:
            public int összeg
            {
                get
                {
                    return érmék[0] * 1 + érmék[1] * 2 + érmék[2] * 5
                        + érmék[3] * 10 + érmék[4] * 20 + érmék[5] * 50 + érmék[6] * 100;
                }
            }
        }

        static void Main(string[] args)
        {
            #region 1. feladat: Az adatok beolvasása, adatszerkezet feltöltése
            Console.WriteLine("1. Feladat: Adatok olvasása, adatszerkezet feltöltése");
            List<rekesz> rekeszek = new List<rekesz>();
            using (StreamReader sr = new StreamReader("csoki.txt"))
            {
                int rdb = int.Parse(sr.ReadLine());
                for (int i = 0; i < rdb; i++)
                {
                    string s = sr.ReadLine();
                    string[] fields = s.Split(' ');
                    rekesz új_rekesz = new rekesz()
                    {
                        r_ssz = byte.Parse(fields[0]),
                        db = int.Parse(fields[1]),
                        ár = int.Parse(fields[2])
                    };
                    rekeszek.Add(új_rekesz);
                }
            }

            List<vásárlás> vásárlások = new List<vásárlás>();
            using (StreamReader sr = new StreamReader("vasarlas.txt"))
            {
                int vdb = int.Parse(sr.ReadLine());
                for (int i = 0; i < vdb; i++)
                {
                    string[] fields = sr.ReadLine().Split(' ');
                    vásárlás új_vásárlás = new vásárlás();
                    új_vásárlás.vssz = i + 1; //6. feladathoz
                    új_vásárlás.vrek = byte.Parse(fields[0]);
                    új_vásárlás.vdb = byte.Parse(fields[1]);
                    int[] új_érmék = new int[7];
                    for (int j = 0; j < 7; j++) új_érmék[j] = int.Parse(fields[j + 2]);
                    új_vásárlás.érmék = új_érmék;
                    vásárlások.Add(új_vásárlás);
                }
            }
            #endregion

            #region 2. feladat: Mennyi az automatában lévő csokik értéke?
            Console.WriteLine("\n2. Feladat: Mennyi az automatában lévő csokik értéke?");
            int csokik_értéke = (from i in rekeszek select i.érték).Sum();
            Console.WriteLine("Az automatában {0} fabatka értékű csokoládé van.", csokik_értéke);
            #endregion

            #region 3. feladat: Mely rekeszekből próbáltak vásárolni?
            Console.WriteLine("\n3. Feladat: Mely rekeszekből próbáltak vásárolni?");
            var vrek = (from i in vásárlások
                        orderby i.vrek //nem volt feladat a rendezés, de így szebb
                        select i.vrek).Distinct();
            foreach (int i in vrek) Console.Write("{0} ", i);
            #endregion

            #region 4. feladat: Anna
            Console.WriteLine("\n4. Feladat: Anna");
            Console.Write("4. feladat: Csokira szánt összeg:");
            int összeg = int.Parse(Console.ReadLine());
            var anna = from r in rekeszek
                       where r.db >= 7 && r.ár * 7 <= összeg
                       select r.r_ssz;
            foreach (var i in anna) Console.Write("{0} ", i);
            #endregion

            #region 5. feladat: Címletek
            Console.WriteLine("\n5. Feladat: Címletek");
            Console.Write("Rekesz: ");
            int rek = int.Parse(Console.ReadLine());
            Console.Write("Darabszám: ");
            int db = int.Parse(Console.ReadLine());
            int fizetendő = (from i in rekeszek where i.r_ssz == rek select i.ár * db).Single();

            Console.WriteLine("Címletek {0} fabatkához:", fizetendő);
            int[] címletek = { 100, 50, 20, 10, 5, 2, 1 };
            for (int i = 0; i < címletek.Length; i++)
                if (fizetendő >= címletek[i])
                {
                    Console.WriteLine("{0,-4} {1}db", címletek[i], fizetendő / címletek[i]);
                    fizetendő %= címletek[i];
                }
            #endregion

            #region 6. feladat: rekesz7.txt kiírása
            Console.WriteLine("\n6. Feladat: rekesz7.txt kiírása");
            using (StreamWriter sw = new StreamWriter("rekesz7.txt"))
            {
                rekesz rek7 = rekeszek[6];
                var v7 = from i in vásárlások
                         where i.vrek == 7
                         select i;

                foreach (var i in v7)
                {
                    sw.Write("{0}. ", i.vssz);
                    if (i.vdb > rek7.db) sw.WriteLine("Kevés a csoki!");
                    else if (i.összeg < rek7.ár * i.vdb) sw.WriteLine("Nem volt elég pénz!");
                    else
                    {
                        sw.WriteLine(i.vdb);
                        rek7.db -= i.vdb;
                    }
                }
            }
            #endregion

            Console.ReadKey();
        }

    }
}